SystemOrganization addCategory: #ConfigurationOfGlorpDBX!

Object subclass: #ConfigurationOfGlorpDBX
	instanceVariableNames: 'project'
	classVariableNames: 'LastVersionLoad'
	poolDictionaries: ''
	category: 'ConfigurationOfGlorpDBX'!

!ConfigurationOfGlorpDBX class methodsFor: 'private' stamp: 'EstebanLorenzano 12/7/2009 11:24'!
bootstrapPackage: aString from: aPath 
	| repository version |
	repository := MCHttpRepository
				location: aPath
				user: ''
				password: ''.
	repository
		versionReaderForFileNamed: aString , '.mcz'
		do: [:reader | 
			version := reader version.
			version load.
			version workingCopy repositoryGroup addRepository: repository]! !

!ConfigurationOfGlorpDBX class methodsFor: 'private' stamp: 'DaleHenrichs 1/6/2010 16:47'!
ensureMetacello
	"Bootstrap Gofer (if necessary), bootstrap ConfigurationOfMetacello (using old Gofer API), then load the latest 
	version of Metacello itself."

	Smalltalk at: #MetacelloProject ifAbsent: [
		Smalltalk at: #Gofer ifAbsent: [
			"Current version of Gofer from which to bootstrap - as of 1.0-beta.15"
			self bootstrapPackage: 'Gofer-lr.83' from: 'http://seaside.gemstone.com/ss/metacello' ].
		Smalltalk at: #Gofer ifPresent: [:goferClass | | gofer |
			gofer := goferClass new
				url: 'http://seaside.gemstone.com/ss/metacello';
				yourself.
			[ gofer addPackage: 'ConfigurationOfMetacello' ] on: Warning do: [:ex | ex resume ].
			gofer load ].
		"load 'default' group of Metacello"
		(Smalltalk at: #ConfigurationOfMetacello) perform: #load ]! !

!ConfigurationOfGlorpDBX class methodsFor: 'metacello tool support' stamp: 'EstebanLorenzano 12/7/2009 11:24'!
isMetacelloConfig
	"Answer true and the Metacello tools will operate on you"
	
	^true! !

!ConfigurationOfGlorpDBX class methodsFor: 'metacello tool support' stamp: 'EstebanLorenzano 12/7/2009 11:24'!
lastMetacelloVersionLoad
	"Answer the last version loaded and the list of packages loaded for that version."

	LastVersionLoad == nil ifTrue: [ LastVersionLoad := nil -> 'default' ].
	^LastVersionLoad! !

!ConfigurationOfGlorpDBX class methodsFor: 'metacello tool support' stamp: 'EstebanLorenzano 12/7/2009 11:24'!
metacelloVersion: versionString loads: anArrayOrString
	"Stash the last version loaded and the list of packages loaded for that version. The list
	 of packages will be used by the tools when doing 'Load Package Version'"

	LastVersionLoad := versionString -> anArrayOrString! !

!ConfigurationOfGlorpDBX class methodsFor: 'accessing' stamp: 'EstebanLorenzano 12/7/2009 11:24'!
project

	^self new project! !

!ConfigurationOfGlorpDBX methodsFor: 'baselines' stamp: 'MarianoMartinezPeck 5/7/2011 17:44'!
baseline20: spec
	<version: '2.0-baseline'>
	
	spec for: #common do: [
		spec blessing: #baseline.
		spec repository: 'http://www.squeaksource.com/DBXTalk'.

		spec project: 'Glorp' with: [ spec
				className: 'ConfigurationOfGlorp';
				file: 'ConfigurationOfGlorp';
				repository: 'http://www.squeaksource.com/DBXTalk'.
				].
			
		spec project: 'GlorpTests' with: [ spec
				className: 'ConfigurationOfGlorp';
				loads: #( 'Dev' );
				file: 'ConfigurationOfGlorp';
				repository: 'http://www.squeaksource.com/DBXTalk'.
				 ].
			
		spec project: 'OpenDBXDriver' with: [
			spec
				className: 'ConfigurationOfOpenDBXDriver';
				file: 'ConfigurationOfOpenDBXDriver';
				loads: #( 'Core' 'Benchmarks');
				repository: 'http://www.squeaksource.com/DBXTalk'. ].
			
		spec project: 'OpenDBXDriver Tests'
					copyFrom: 'OpenDBXDriver'
					with: [ spec loads: #('Tests') ].
			
		spec package: 'GlorpOpenDBXDriver' with: [
			spec postLoadDoIt: #postLoadGlorpDriverDBXTalk.
			spec requires: #('OpenDBXDriver' ) ] .
		
		spec package: 'GlorpOpenDBXDriverTests' with: [
			spec requires: #('GlorpOpenDBXDriver' 'GlorpTests'  ) ] .
		
		spec
			group: 'default' with: #('ALL');
			group: 'Core' with: #('Glorp');
			group: 'Tests' with: #('GlorpTests' 'OpenDBXDriver Tests'  'GlorpOpenDBXDriverTests');
			group: 'GlorpDBX' with: #('Core' 'OpenDBXDriver' 'GlorpOpenDBXDriver');
			yourself.
			
	]		
			
			! !

!ConfigurationOfGlorpDBX methodsFor: 'doits' stamp: 'MarianoMartinezPeck 5/7/2011 18:47'!
postLoadGlorpDriverDBXTalk
	(Smalltalk at: #PharoDatabaseAccessor) DefaultDriver: (Smalltalk globals at: #GlorpOpenDBXDriver).
	"If the connection pool driver is desired, just evaluate:
	 PharoDatabaseAccessor DefaultDriver: GlorpOpenDBXDriverPoolingDriver
	
	"
	
Transcript open.
	Transcript show: 'IMPORTANT FOR GLORP AND OpenDBXDriver DRIVER'; cr;
	show: 'In order to run sucessfully Glorp tests you should need to change the database connection settings used by them. To do this, change the following methods:
	-GlorpDatabaseLoginResource>>defaultPostgreSQLInternetLogin
	-GlorpDatabaseLoginResource>>defaultPostgreSQLLocalLogin
	-GlorpDatabaseLoginResource>>defaultPostgreSQLLoginForGlorpStore

	After doing this all Glorps tests must be green.'
	! !

!ConfigurationOfGlorpDBX methodsFor: 'accessing' stamp: 'EstebanLorenzano 12/7/2009 11:24'!
project

	^ project ifNil: [ | constructor |
		"Bootstrap Metacello if it is not already loaded"
		self class ensureMetacello.
		"Construct Metacello project"
		constructor := (Smalltalk at: #MetacelloVersionConstructor) on: self.
		project := constructor project ]! !

!ConfigurationOfGlorpDBX methodsFor: 'accessing' stamp: 'GuillermoPolito 4/26/2011 05:12'!
stable: spec 
	<symbolicVersion: #stable>
	
	spec for: #'pharo1.2.x' version: '2.0'. 
! !

!ConfigurationOfGlorpDBX methodsFor: 'versions' stamp: 'MarianoMartinezPeck 5/7/2011 00:03'!
version20: spec
	<version: '2.0' imports: #('2.0-baseline')>
	
	spec for: #common do: [
		
		spec blessing: #development.
		
		spec project: 'OpenDBXDriver' with: '1.3'.
		spec project: 'OpenDBXDriver Tests' with: '1.3'.		
		spec project: 'Glorp' with: '1.0'. 
		spec project: 'GlorpTests' with: '1.0'.
		
		spec package: 'GlorpOpenDBXDriverTests' with: 'GlorpOpenDBXDriver-MarianoMartinezPeck.2'.
		spec package: 'GlorpOpenDBXDriver' with: 'GlorpOpenDBXDriverTests-MarianoMartinezPeck.1'.
		
	]! !
